package com.crm.pay.controller.pay;

import com.crm.pay.controller.base.BasePayCloseFunctionController;
import com.crm.pay.entity.callback.NganluongCallbackEntity;
import com.crm.pay.service.NganluongService;
import com.crm.rely.backend.model.constant.PayConstants;
import com.crm.rely.backend.core.dto.base.BaseResultDto;
import com.crm.pay.dto.PayDto;
import com.crm.rely.backend.model.entity.custom.info.CustomInfoEntity;
import com.crm.rely.backend.model.entity.finance.deposit.FinanceDepositAddEntity;
import com.crm.pay.entity.FinanceDepositParameterEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.math.BigDecimal;

/**
 * @program:
 * @description:
 * @author: houn
 * @create: 2020-12-05 18:58
 */
@RestController
@RequestMapping("/nganluong")
public class NganluongController extends BasePayCloseFunctionController {

    @Autowired
    private NganluongService service;


    /**
     * 支付
     *
     * @param login  入金账号
     * @param amount 入金金额
     * @return
     * @throws Exception
     */
    @RequestMapping("/pay/{login}/{amount}/{bankCode}")
    public BaseResultDto pay(@PathVariable("login") Long login,
                             @PathVariable("amount") BigDecimal amount,
                             @PathVariable("bankCode") String bankCode,
                             @RequestBody FinanceDepositParameterEntity entity,
                             CustomInfoEntity infoEntity, HttpServletRequest request) throws Exception {

        return payCall(login, amount, bankCode, 0, entity, infoEntity, request);
    }

    @RequestMapping("/pay/{login}/{amount}/{bankCode}/{activity}")
    public BaseResultDto pay(@PathVariable("login") Long login,
                             @PathVariable("amount") BigDecimal amount,
                             @PathVariable("bankCode") String bankCode,
                             @PathVariable("activity") int activity,
                             @RequestBody FinanceDepositParameterEntity entity,
                             CustomInfoEntity infoEntity, HttpServletRequest request) throws Exception {
        return payCall(login, amount, bankCode, activity, entity, infoEntity, request);
    }

    private BaseResultDto payCall(Long login,
                                  BigDecimal amount,
                                  String bankCode,
                                  int activity,
                                  FinanceDepositParameterEntity entity,
                             CustomInfoEntity infoEntity, HttpServletRequest request) throws Exception {
        validated(login, amount);

        FinanceDepositAddEntity financeDepositSaveEntity = getFinanceDepositSaveEntity(login, amount, bankCode,
                PayConstants.NGANLUONG_PAY_TYPE_KEY, activity, entity, request);

        String url = service.pay(financeDepositSaveEntity);
        PayDto payDto = new PayDto(1, url);
        return BaseResultDto.success(payDto);
    }

    /**
     * 异步回调
     *
     * @param request 用于获取回调数据
     * @return 返回成功给第三方系统
     * @throws Exception
     */
    @PostMapping(value = "/callback", produces = "text/html")
    public String callback(HttpServletRequest request, HttpServletResponse response) throws Exception {

        NganluongCallbackEntity safeCallbackEntity = getCallback(request);

        service.callback(safeCallbackEntity);

        sendRedirect(response);

        return PayConstants.NGANLUONG_SUCCESS_RESULT;
    }

    /**
     * 同步页面 成功
     *
     * @param response 用于重定向页面
     * @throws IOException
     */
    @GetMapping(value = "/pickup")
    public void pickup(HttpServletResponse response) throws Exception {
        sendRedirect(response);
    }

    /**
     * 在form-data中获取回调数据
     *
     * @param request 用于获取form-data中的数据
     * @return 返回回调数据构建的实体
     */
    protected NganluongCallbackEntity getCallback(HttpServletRequest request) {
        String errorCode = request.getParameter("error_code");
        String orderCode = request.getParameter("order_code");
        String orderId = request.getParameter("order_id");
        String token = request.getParameter("token");
        NganluongCallbackEntity nganluongCallbackEntity = new NganluongCallbackEntity();
        nganluongCallbackEntity.setErrorCode(errorCode);
        nganluongCallbackEntity.setOrderCode(orderCode);
        nganluongCallbackEntity.setOrderId(orderId);
        nganluongCallbackEntity.setToken(token);
        return nganluongCallbackEntity;
    }
}
